#include <stdio.h>
#include <math.h>
#include <limits.h>  /* enth\"alt die Konstante INT_MAX */

int main()
{
	float summe1 = 0.0,summe2 = 0.0;
	int i,n;
	char tempstring[80];
	
	printf("Der erste Algorithmus wird ungenau f\"ur n bei ca. %f \n",
		ceil(sqrt(1.0/1.0e-6)) );  
	/* siehe Kommentar 1.Schranke */
	
	printf("Weitere Fehler ergeben sich f\"ur n >= %f, \n",
	        ceil(sqrt(INT_MAX)) );
	/* siehe Kommentar 2.Schranke */
	
	printf("Geben Sie die obere Summationsschranke n an : ");
	fgets(tempstring, sizeof(tempstring), stdin);
	sscanf(tempstring, "%i", &n);		
	
	for (i=1; i<=n; i++)
	{ 
		/* 1. Schranke f\"ur i */					
		/* Der Summand 1.0/(i*i) wird bei der Addition */
		/* nich mehr ber\"ucksichtigt, falls 1.0/(i*i) < 1.0e-6 */

		/* 2. Schranke f\"ur i */					
		/* Das Produkt i*i ist als int-Variable nicht */
		/* mehr darstellbar, falls i*i > INT_MAX */
					
		summe1=summe1+1.0/(i*i);
	}
	
	for (i=n; i>=1; i--)
	{ 
		summe2=summe2+1.0/i/i;
	}
    
	printf("Der erste Algorithmus liefert das Ergebnis : %f \n",summe1);
	printf("Der zweite Algorithmus liefert das Ergebnis : %f \n",summe2);
	return 0;
}	
